/* Copyright 2009 Fog Creek Software, Inc. */

using System;
using System.Collections.Generic;
using System.Text;
using System.Web;

/* FogBugz namespaces-- make sure you add the neccesary assembly references to
 * the following DLL files contained in C:\Program Files\FogBugz\Website\bin\ 
 * FogBugz.dll, FogCreek.Plugins.dll, FogCreek.Plugins.InterfaceEvents.dll     */
using FogCreek.FogBugz.Plugins;
using FogCreek.FogBugz.Plugins.Api;
using FogCreek.FogBugz.Plugins.Entity;
using FogCreek.FogBugz.Plugins.Interfaces;
using FogCreek.FogBugz;
using FogCreek.FogBugz.UI.Dialog;

namespace IPluginPersonDisplay_Example
{
    /* Class Declaration: Inherit from Plugin, implement IPluginPersonDisplay */
    public class IPluginPersonDisplay_Example : Plugin, IPluginPersonDisplay
    {
        /* Constructor: We'll just initialize the inherited Plugin class, which 
         * takes the passed instance of CPluginApi and sets its "api" member variable. */
        public IPluginPersonDisplay_Example(CPluginApi api)
            : base(api)
        {
        }

        #region IPluginPersonDisplay Members

        public FogCreek.FogBugz.UI.Dialog.CDialogItem[] PersonDisplayEdit(CPerson person)
        {
            /* display a dialog item for the Person Edit (User options) page with content,
             * label and instructions html provided */
            return new CDialogItem[] { new CDialogItem(
                @"<input type=""checkbox"" name=""unused"" /> 
                Created by PersonDisplayEdit method.", "Plugin Example",
                "Instructions are shown here.") };
        }

        public string[] PersonDisplayListFields(CPerson person)
        {
            /* Display a field containing a link to the Person's homepage in the User list */
            return new string[] { string.Format(
                @"<a href=""{0}"" target=""_blank"">{0}</a>", 
                HttpUtility.HtmlEncode(person.sHomepage)) };
        }

        public string[] PersonDisplayListHeaders()
        {
            /* Display a label for our new field */
            return new string[] { "Homepage" };
        }

        #endregion
    }
}